/*
 * (c) Copyright 2011 PaperCut Software International Pty. Ltd.
 */
package biz.papercut.pcng.plugin;

import java.util.Map;

/**
 * 4th version of top-up account on demand plugin - adds a balance check.  Balances are mainly used for display
 * purposes, as distinct from {@link #getAvailableCreditForTopUp available credit}
 */
public interface TopupAccountOnDemandPlugin4 extends TopupAccountOnDemandPlugin3 {
    /** The user's unique username. */
    String USER_DETAILS_USERNAME = "username";
    /** The user's id number. */
    String USER_DETAILS_ID = "id";
    /** The user's card number. */
    String USER_DETAILS_CARD = "card";

    /**
     * @param userDetails A map of the user's details.  Valid keys are:
     * <ul>
     *   <li>{@link #USER_DETAILS_USERNAME}</li>
     *   <li>{@link #USER_DETAILS_ID}</li>
     *   <li>{@link #USER_DETAILS_CARD}</li>
     * </ul>
     * All details are optional but at least one will be included.
     * @return A map of the user's balance(s) and associated label(s).  E.g.:
     * <pre>
     *{
     *  "Cash": 1.20,
     *  "Credit": 20.00
     *}
     *</pre>
     * {@code null} may be returned to indicate an error case, such as user not being found, or if the plugin determines
     * that the balance should not be displayed.
     */
    Map<String, Double> getBalance(Map<String, String> userDetails);
}
